diff -r 1c03bc321e39 django/contrib/databrowse/datastructures.py
--- a/django/contrib/databrowse/datastructures.py	Wed Dec 30 19:11:11 2009 -0300
+++ b/django/contrib/databrowse/datastructures.py	Thu Dec 31 10:03:16 2009 -0300
@@ -158,7 +158,7 @@
                 if isinstance(self.field, models.DateTimeField):
                     objs = capfirst(formats.date_format(self.raw_value, 'DATETIME_FORMAT'))
                 elif isinstance(self.field, models.TimeField):
-                    objs = capfirst(formats.date_format(self.raw_value, 'TIME_FORMAT'))
+                    objs = capfirst(formats.time_format(self.raw_value, 'TIME_FORMAT'))
                 else:
                     objs = capfirst(formats.date_format(self.raw_value, 'DATE_FORMAT'))
             else:
diff -r 1c03bc321e39 django/template/defaultfilters.py
--- a/django/template/defaultfilters.py	Wed Dec 30 19:11:11 2009 -0300
+++ b/django/template/defaultfilters.py	Thu Dec 31 10:03:16 2009 -0300
@@ -18,7 +18,7 @@
 from django.utils.translation import ugettext, ungettext
 from django.utils.encoding import force_unicode, iri_to_uri
 from django.utils.safestring import mark_safe, SafeData
-from django.utils.formats import date_format, number_format
+from django.utils.formats import date_format, time_format, number_format
 
 register = Library()
 
@@ -696,16 +696,16 @@
 
 def time(value, arg=None):
     """Formats a time according to the given format."""
-    from django.utils.dateformat import time_format
+    from django.utils.dateformat import time_format as df_time_format
     if value in (None, u''):
         return u''
     if arg is None:
         arg = settings.TIME_FORMAT
     try:
-        return date_format(value, arg)
+        return time_format(value, arg)
     except AttributeError:
         try:
-            return time_format(value, arg)
+            return df_time_format(value, arg)
         except AttributeError:
             return ''
 time.is_safe = False
diff -r 1c03bc321e39 django/utils/formats.py
--- a/django/utils/formats.py	Wed Dec 30 19:11:11 2009 -0300
+++ b/django/utils/formats.py	Thu Dec 31 10:03:16 2009 -0300
@@ -53,6 +53,12 @@
     """
     return dateformat.format(value, get_format(format or 'DATE_FORMAT'))
 
+def time_format(value, format=None):
+    """
+    Formats a datetime.time object using a localizable format
+    """
+    return dateformat.time_format(value, get_format(format or 'TIME_FORMAT'))
+
 def number_format(value, decimal_pos=None):
     """
     Formats a numeric value using localization settings
@@ -90,7 +96,7 @@
                 return value.strftime(get_format('DATE_INPUT_FORMATS')[0])
         elif isinstance(value, datetime.time):
             if not is_input:
-                return date_format(value, 'TIME_FORMAT')
+                return time_format(value, 'TIME_FORMAT')
             else:
                 return value.strftime(get_format('TIME_INPUT_FORMATS')[0])
     return value
diff -r 1c03bc321e39 tests/regressiontests/i18n/tests.py
--- a/tests/regressiontests/i18n/tests.py	Wed Dec 30 19:11:11 2009 -0300
+++ b/tests/regressiontests/i18n/tests.py	Thu Dec 31 10:03:16 2009 -0300
@@ -4,7 +4,7 @@
 
 from django.template import Template, Context
 from django.conf import settings
-from django.utils.formats import get_format, date_format, number_format, localize
+from django.utils.formats import get_format, date_format, time_format, number_format, localize
 from django.utils.numberformat import format
 from django.test import TestCase, client
 from django.utils.translation import ugettext, ugettext_lazy, activate, deactivate, gettext_lazy
@@ -90,8 +90,10 @@
         self.f = 99999.999
         self.d = datetime.date(2009, 12, 31)
         self.dt = datetime.datetime(2009, 12, 31, 20, 50)
+        self.t = datetime.time(10, 15, 48)
         self.ctxt = Context({
             'n': self.n,
+            't': self.t,
             'd': self.d,
             'dt': self.dt,
             'f': self.f
@@ -102,10 +104,10 @@
         settings.USE_I18N = self._use_i18n
         settings.USE_L10N = self._use_l10n
         settings.USE_THOUSAND_SEPARATOR = self._use_thousand_separator
-    
+
     def test_locale_independent(self):
         """
-        Localization of dates and numbers
+        Localization of numbers
         """
         settings.USE_L10N = True
         settings.USE_THOUSAND_SEPARATOR = False
@@ -129,6 +131,7 @@
             self.assertEqual('N j, Y', get_format('DATE_FORMAT'))
             self.assertEqual(0, get_format('FIRST_DAY_OF_WEEK'))
             self.assertEqual('.', get_format('DECIMAL_SEPARATOR'))
+            self.assertEqual(u'10:15 a.m.', time_format(self.t))
             self.assertEqual(u'des. 31, 2009', date_format(self.d))
             self.assertEqual(u'desembre 2009', date_format(self.d, 'YEAR_MONTH_FORMAT'))
             self.assertEqual(u'12/31/2009 8:50 p.m.', date_format(self.dt, 'SHORT_DATETIME_FORMAT'))
@@ -143,6 +146,7 @@
             self.assertEqual(u'2009-12-31 20:50:00', Template('{{ dt }}').render(self.ctxt))
             self.assertEqual(u'66666.67', Template('{{ n|floatformat:2 }}').render(self.ctxt))
             self.assertEqual(u'100000.0', Template('{{ f|floatformat }}').render(self.ctxt))
+            self.assertEqual(u'10:15 a.m.', Template('{{ t|time:"TIME_FORMAT" }}').render(self.ctxt))
             self.assertEqual(u'12/31/2009', Template('{{ d|date:"SHORT_DATE_FORMAT" }}').render(self.ctxt))
             self.assertEqual(u'12/31/2009 8:50 p.m.', Template('{{ dt|date:"SHORT_DATETIME_FORMAT" }}').render(self.ctxt))
 
@@ -183,6 +187,7 @@
             self.assertEqual('j \de F \de Y', get_format('DATE_FORMAT'))
             self.assertEqual(1, get_format('FIRST_DAY_OF_WEEK'))
             self.assertEqual(',', get_format('DECIMAL_SEPARATOR'))
+            self.assertEqual(u'10:15:48', time_format(self.t))
             self.assertEqual(u'31 de desembre de 2009', date_format(self.d))
             self.assertEqual(u'desembre del 2009', date_format(self.d, 'YEAR_MONTH_FORMAT'))
             self.assertEqual(u'31/12/2009 20:50', date_format(self.dt, 'SHORT_DATETIME_FORMAT'))
@@ -209,6 +214,7 @@
             self.assertEqual(u'31 de desembre de 2009 a les 20:50', Template('{{ dt }}').render(self.ctxt))
             self.assertEqual(u'66666,67', Template('{{ n|floatformat:2 }}').render(self.ctxt))
             self.assertEqual(u'100000,0', Template('{{ f|floatformat }}').render(self.ctxt))
+            self.assertEqual(u'10:15:48', Template('{{ t|time:"TIME_FORMAT" }}').render(self.ctxt))
             self.assertEqual(u'31/12/2009', Template('{{ d|date:"SHORT_DATE_FORMAT" }}').render(self.ctxt))
             self.assertEqual(u'31/12/2009 20:50', Template('{{ dt|date:"SHORT_DATETIME_FORMAT" }}').render(self.ctxt))
 